package CoreSim::DB::DBI;

use strict;
use DBI;

sub new(){
	
	my $invocant = shift;
	my ($dbName) = @_;
	
	my $class = ref($invocant) || $invocant;
	
	my $dbHandle = DBI->connect("dbi:SQLite:dbname=$dbName");	
	
	if ($dbHandle->err){
		printf("Error while trying to connect to the database %s\n!", $dbName);
		exit;	
	}
	
	my $self={
		"dbHandle" => $dbHandle,
		"dbName" => $dbName,
	};
	
	bless($self, $class);
	
	&copyDBToMemory($self);
	
	return $self;
}

sub addLatency(){
	my $self=shift;
	my ($ip1, $ip2, $latency) = @_;
	
	#insert new latency into the database
	my $dbHandle = $self->{"dbHandle"};
	my $cmd = "INSERT INTO latencies ('IP1', 'IP2', 'latency') VALUES ('$ip1', '$ip2', '$latency')";
	
	$dbHandle->do($cmd);
	
	#store the latency into memory also 
	$self->{"dbHash"}->{$ip1}{$ip2} = $latency;
	
}

sub getLatency(){
	my $self=shift;
	my ($ip1, $ip2) = @_;
	
	#for now skip searching in the sqlite db and search the RAM stored dbHASH
#	my $dbHandle = $self->{"dbHandle"};
#	
#	my $query =  "SELECT latency FROM latencies WHERE (IP1 = '$ip1' AND IP2 = '$ip2' ) OR (IP1 = '$ip2' AND IP2 = '$ip1')";
#	my $latency = $dbHandle->selectrow_array($query);
	
	if (defined($self->{"dbHash"}->{$ip1}{$ip2})){
		return $self->{"dbHash"}->{$ip1}{$ip2};
	}elsif( defined($self->{"dbHash"}->{$ip2}{$ip1}) ){
		return $self->{"dbHash"}->{$ip2}{$ip1};
	}else{
		return undef;
	}
	
	
}

sub copyDBToMemory(){
	my $self=shift;
	
	my $dbHandle = $self->{"dbHandle"};
	my $allEntries = $dbHandle->selectall_arrayref("SELECT * FROM latencies");
	my $dbHash = {};
	
	foreach my $row (@$allEntries){
		my ($ip1, $ip2, $latency) = @$row;
		
		$dbHash->{$ip1}{$ip2} = $latency;
	
	}
	
	$self->{"dbHash"} = $dbHash;
}

sub DESTROY(){
	my $self=shift;
	my $dbHandle = $self->{"dbHandle"};
	$dbHandle->disconnect();
}

#return 1 at the end
1