package CoreSim::ITR::DiscardBuffer;

use strict;

sub new(){
	my $invocant = shift;
	
	my $class = ref($invocant) || $invocant;
	
	my $ipBuffer = {};
	
	my $self={
		"ipBuffer" => $ipBuffer,
	};
	
	bless($self, $class);
	
	return $self;
}

sub addEntry(){
	my $self=shift;
	my ($ip,$destinationPrefix) = @_;
	
	my $ipBuffer = $self->{"ipBuffer"};
	
	#add the entry to the ipBuffer hash, the value is not that important (it matters just to check that it is defined)
	$ipBuffer->{$ip} = $destinationPrefix;
	
}

sub ipInBuffer(){
	my $self=shift;
	my $ip = shift;
	
	my $ipBuffer = $self->{"ipBuffer"};
	
	if ( defined($ipBuffer->{$ip}) ){
		return 1;
	}else{
		return 0;
	}
}

sub getPrefixForIP(){
	my $self=shift;
	my $ip = shift;
	
	return $self->{"ipBuffer"}->{$ip};	
}

#return 1 at the end
1