package CoreSim::Scenario::Scenario1;

use strict;
use CoreSim::Chord;

sub new(){
	my $invocant = shift;
	
	my ($itr, $traceFilePath, $_DEBUG) = @_;
	
	my $class = ref($invocant) || $invocant;
	
	my $self={
		"traceFilePath" => $traceFilePath,
		"itr" => $itr,
		"_DEBUG" => $_DEBUG,
	};
	
	bless($self, $class);
	return $self;
}

#read a parsed ERF file with a structure: <timestamp> <destinationip>
sub runSimulation(){
	
	my $self= shift;
	my $inputFilePath = $self->{"traceFilePath"};
	my $itr = $self->{"itr"};
	
	my $traceData;
	open(IFILE, $inputFilePath) or die printf("(Scen1)(EE)Can't open trace file %s:%s\n", $inputFilePath, $!);
	
	my $count = 0;
	
	while(<IFILE>){
		my @line = split;
		
		my $timestamp= $line[0];
		my $destinationIP=$line[1];
		my $protocol = $line[2];
		my $size = $line[3];
		
		#filter out destination IP addresses above 223.255.255.255
		if (!&isDEIPClass($destinationIP) && !&firstEightBitsZero($destinationIP) ){
			my $itrLatency = $itr->searchForIP($destinationIP, $timestamp, $protocol, $size);
			
			if (defined($itrLatency)){
				printf("(Scen1) The latency implied by the search for IP %s in the mapping system is %s \n", $destinationIP, $itrLatency)
					if ($self->{"_DEBUG"}>=2);
			}
#			$count++;
#			if ($count == 10000){ last;}
		
		}
	}
			
	close(IFILE);
}

sub isDEIPClass(){
	my $ip = shift;
	
	my @result = split(/\./, $ip);
	if ($result[0] >= 224){
		return 1;
	}else{
		return 0;
	}
}

sub firstEightBitsZero(){
	
	my $ip = shift;
	
	my @result = split(/\./, $ip);
	if ($result[0] == 0 ){
		return 1;
	}else{
		return 0;
	}
}
#return 1 at the end
return 1;