package CoreSim::Utilities::Timeline;

use strict;


#all the elements in the list are HASHES and have the keys "next" and "value"
sub new(){
	
	my $invocant = shift;
	my ($ipUtility, $_DEBUG) = @_;
	
	my $class = ref($invocant) || $invocant;
	
	my $list;
	
	my $self={
		"list" => $list,
		"ipUtility" => $ipUtility,
		"_DEBUG" => $_DEBUG,
	
	};
	
	bless($self, $class);
	
	return $self;
}

sub addElement(){
	my $self=shift;
	my ($timestamp, $object) = @_;
	
	my $list = $self->{"list"};

	my $element = {"next"=>undef, "timestamp" => $timestamp, "object"=> $object};
	
	#first element
	if (!defined($list)){
		$self->{"list"} = $element;
		printf("inserting %s as the first element\n", $timestamp) if ($self->{"_DEBUG"}>=2);
#		&printListTimestamps($self);
		
	}else{
		my $predecessor;
		my $endLoop = 0;
		
		#find the insertion position
		while ((defined($list)) && ($list->{"timestamp"} lt $element->{"timestamp"}) ){
			$predecessor = $list;
			$list = $list->{"next"};
		}
		
		#make the insertion
		
		#if the predecessor is not defined then the new element will be the first element in the list
		if (!defined($predecessor)){
			$element->{"next"} = $list;
			$self->{"list"} = $element;
			printf("inserting %s as the first element of the list\n", $timestamp) if ($self->{"_DEBUG"});

		
		#otherwise make the insertion after predecessor
		}else{
			$element->{"next"} = $predecessor->{"next"};
			$predecessor->{"next"} = $element;
			printf("inserting %s as the element after %s in the list\n", $timestamp, $predecessor->{"timestamp"}) if ($self->{"_DEBUG"});

		}
		
	}
	
}

sub firstElement(){
	my $self=shift;
	
	my $list=$self->{"list"};
	
	#return the first object (the first element in the list is a dummy)
	return $list->{"object"};
} 

sub deleteFirstElement(){
	my $self=shift;
	
	my $list = $self->{"list"};
	
	$self->{"list"}=$list->{"next"};
	
	#delete the first element
	undef($list);
#	&printListTimestamps($self);
}

sub printListTimestamps(){
	my $self=shift;
	
	my $list = $self->{"list"};
	
	printf("the list timestamps:\n");
	while(defined($list)){
		printf("%s\n", $list->{"timestamp"});
		$list = $list->{"next"};
	}
	
}

#return 1
1